@ECHO OFF
TITLE = "UnMech-Updater2"
MODE con:cols=80 lines=30

:::::::::::::::::::::::::::::::::::::::::::::::::::::
::-------------------------------------------------::
::---                                           ---::
::---       UnMech-Updater2                     ---::
::---           Made because i care             ---::
::-------------------------------------------------::
::---                                           ---::
::---       Made By:                            ---::
::---                "Eledore Massis"           ---::
::---                                           ---::
::---   For easy installing and update UnMech3  ---::
::---                                           ---::
::-------------------------------------------------::
::---                                           ---::
::---  To use Updater2, place it in             ---::
::---   the MW3 installation directory          ---::
::---    E.G; C:\MicroProse\MechWarrior3        ---::
::---  Or above the 'zbd' folder of your choice ---::
::---   And run/Execute this file.              ---::
::---                                           ---::
::-------------------------------------------------::
:::::::::::::::::::::::::::::::::::::::::::::::::::::

:: Setting COLOR to 'A' Light Green '0' Black
SET COLOR=A0
COLOR %COLOR%


:variables
:: Setting Variables
SET dir=%CD%
SET dsd=%TMP%\UM3
SET dev=%1
SET ver=201
SET discord=wxcHxE9m2F
SET site=unmech3.org
SET url=http://%site%/Updater2
SET source=http://%site%/UnMechUpdater2.bat
GOTO SETUP


:SETUP
:: create Temp directory if not already existing
MKdir %dsd% >Nul 2>&1 
GOTO PRE-CLEANUP


:PRE-CLEANUP
:: pre-cleanup
CD %dsd% >Nul 2>&1 
:: clear existing scripts
DEL /q %dsd%\*.ver  >Nul 2>&1
DEL /q %dsd%\*.txe  >Nul 2>&1
DEL /q %dsd%\*.sh  >Nul 2>&1
CLS
COLOR %COLOR%
GOTO DETECT


:DETECT
CLS
ECHO.%dev%
ECHO.     _     _   
ECHO.    !_;___;_!  
ECHO.   .=:!.-.!:=.   _     _        ______             _        ________
ECHO.   H  "'-'"  H  ! !   ! !       !  ___ \           ! !     (_______/
ECHO.  [o]{/'"'\}[o] ! !   ! !____   ! ! _ ! ! ____ ____! ! _      ____  
ECHO.     d     b    ! !   ! !  _ \  ! !! !! !/ _  ) ___) !! \    (___ \ 
ECHO.    !M     M!   ! !___! ! ! ! ! ! !! !! ( (/ ( (___! ! ! !  _____) )
ECHO.    O       O    \______!_! !_! !_!!_!!_!\____)____)_! !_! (______/ 
ECHO.   .A.     .A. 
ECHO.-------------------------------------------------
ECHO.---   Fetching Latest Script                  ---
ECHO.-------------------------------------------------
ECHO.---                                           ---
ECHO.---   Please Standing By...                   ---
ECHO.---                                           ---
ECHO.-------------------------------------------------
TIMEOUT /T 2 >Nul 2>&1
:: IF 'x' dev variable is used, Bypass is game running step.
:: x variable will force close the game and update
ECHO.%dev%| FIND /I "x">Nul && (GOTO SITE-TEST) || (ECHO.)
:: Check if UnMech3.exe is already running
QPROCESS "UnMech3.exe">Nul
IF %ERRORLEVEL% EQU 0 GOTO DETECTED
GOTO SITE-TEST


:SITE-TEST
:: Testing if unmech3.org exists
PING -n 1 "%site%" | FINDSTR /r /c:"[0-9] *ms" 
IF %errorlevel% == 0 (echo.) ELSE (GOTO SITE-FAILURE)
curl -s -m 1 %source% > Nul && ECHO. || GOTO SITE-FAILURE
GOTO CURL-FETCH


:CURL-FETCH
:: Download scripts through http
CLS
ECHO.%dev%
ECHO.     _     _   
ECHO.    !_;___;_!  
ECHO.   .=:!.-.!:=.   _     _        ______             _        ________
ECHO.   H  "'-'"  H  ! !   ! !       !  ___ \           ! !     (_______/
ECHO.  [o]{/'"'\}[o] ! !   ! !____   ! ! _ ! ! ____ ____! ! _      ____  
ECHO.     d     b    ! !   ! !  _ \  ! !! !! !/ _  ) ___) !! \    (___ \ 
ECHO.    !M     M!   ! !___! ! ! ! ! ! !! !! ( (/ ( (___! ! ! !  _____) )
ECHO.    O       O    \______!_! !_! !_!!_!!_!\____)____)_! !_! (______/ 
ECHO.   .A.     .A. 
ECHO.-------------------------------------------------
ECHO.---   UnMech3 Fetching Latest Script          ---
ECHO.-------------------------------------------------
ECHO.---                                           ---
ECHO.---   Downloading Update Script...            ---
ECHO.---                                           ---
ECHO.-------------------------------------------------
:: Downloading latest scripts
curl --output %dsd%/version.ver %url%/version.ver >Nul 2>&1
curl --output %dsd%/UnMechUpdater2.sh %url%/UnMechUpdater2.sh >Nul 2>&1
curl --output %dsd%/UnMechInstaller.txe %url%/Scripts/UnMechInstaller.txe >Nul 2>&1
echo.%url%/UnMechUpdater2.sh
echo.%url%/Scripts/UnMechInstaller.txe
GOTO CLEANUP


:CLEANUP
:: Extract Updater2 version number
findstr "version=" "%dsd%\UnMechUpdater2.sh" > "%dsd%\UnMechUpdater2.ver"
SET /P firstline=<%dsd%\UnMechUpdater2.ver
DEL %dsd%\UnMechUpdater2.ver
SET testver=%firstline:~8,3%
:: Compare this file vs latest Updater2 version
echo.ver:%ver%
echo.testver:%testver%
if %testver% GTR %ver% (GOTO WARNING) ELSE (ECHO.)
:: Prepair existing UMI
DEL /q %dsd%\UnMechInstaller.bat >Nul 2>&1 
COPY %dsd%\UnMechInstaller.txe %dsd%\UnMechInstaller.bat >Nul 2>&1 
DEL /q %dsd%\UnMechInstaller.txe >Nul 2>&1 
GOTO RUN


:ERROR
CLS
COLOR 4f
ECHO.%dev%
ECHO.-------------------------------------------------
ECHO.---            ~!~ WARNING ~!~                ---
ECHO.-------------------------------------------------
ECHO.---                                           ---
ECHO.---     UnMech3-Updater2                       ---
ECHO.---   Something Went Wrong!                   ---
ECHO.---   Please contact a UnMech3 Developer      ---
ECHO.---                                           ---
ECHO.-------------------------------------------------
ECHO.---   How to get help?                        ---
ECHO.---    Discord                                ---
ECHO.---    'MechWarrior 3 Community Project'      --
ECHO.---         https://discord.gg/%discord%     ---
ECHO.---           #help_w_unmech3                 ---
ECHO.-------------------------------------------------
COLOR %COLOR%
GOTO END

:WARNING
CLS
COLOR 4f
ECHO.%dev%
ECHO.-------------------------------------------------
ECHO.---            ~!~ WARNING ~!~                ---
ECHO.-------------------------------------------------
ECHO.---                                           ---
ECHO.---     UnMech-Updater2                       ---
ECHO.---   You are running a outdated Updater2     ---
ECHO.---    Your version    '%ver%'                  ---
ECHO.---    Latest version  '%testver%'                  ---
ECHO.---                                           ---
ECHO.---   Redirecting you to                      ---
ECHO.---    http://%site%/
ECHO.---                                           ---
ECHO.-------------------------------------------------
ECHO.---   How to get help?                        ---
ECHO.---    Discord                                ---
ECHO.---    'MechWarrior 3 Community Project'      --
ECHO.---         https://discord.gg/%discord%     ---
ECHO.---           #help_w_unmech3                 ---
ECHO.-------------------------------------------------
pause
START "" http://%site%/ 
COLOR %COLOR%
GOTO END

:SITE-FAILURE
CLS
COLOR 4f
ECHO.%dev%
ECHO.-------------------------------------------------
ECHO.---            ~!~ WARNING ~!~                ---
ECHO.-------------------------------------------------
ECHO.---                                           ---
ECHO.---   UnMech-Updater2                         ---
ECHO.---    is unable to connect to:               ---
ECHO.---     http://%site%/
ECHO.---   The website might be down or            ---
ECHO.---    there might be a issue your end.       ---
ECHO.-------------------------------------------------
ECHO.---   How to get help?                        ---
ECHO.---    Discord                                ---
ECHO.---    'MechWarrior 3 Community Project'      ---
ECHO.---         https://discord.gg/%discord%     ---
ECHO.---           #help_w_unmech3                 ---
ECHO.-------------------------------------------------
pause
COLOR %COLOR%
GOTO END

:DETECTED
CLS
COLOR 4f
ECHO.%dev%
ECHO.-------------------------------------------------
ECHO.---            ~!~ WARNING ~!~                ---
ECHO.-------------------------------------------------
ECHO.---                                           ---
ECHO.---     UnMech-Updater2                       ---
ECHO.---   Has detected a UnMech3 Already running  ---
ECHO.---                                           ---
ECHO.---   It can't update with the game running   ---
ECHO.---   Please close UnMech3.exe and try again  ---
ECHO.---                                           ---
ECHO.-------------------------------------------------
ECHO.---   Have problems with UnMech3              ---
ECHO.---     Tell us about it!                     ---
ECHO.---    Discord                                ---
ECHO.---    'MechWarrior 3 Community Project'      ---
ECHO.---        https://discord.gg/%discord%      ---
ECHO.---          #help_w_unmech3                  ---
ECHO.-------------------------------------------------
PAUSE
COLOR %COLOR%
GOTO END


:RUN
START %dsd%\UnMechInstaller.bat "%dir%" "%dev%"
EXIT


:END
CLS
EXIT